const CanvasEditor = require("./canvas-editor.js");
const sharp = require('sharp')
const axios = require('axios')

module.exports.generateCanvas = function (segmentData, options) {
    let CE = new CanvasEditor()
    CE.mount(options)
    for (let i = 0; i < segmentData.object.length; i++) {
        CE.addElement(segmentData.object[i])
    }
    return CE
}

module.exports.mergeImages = async function (imageArr, options) {
    let imageSharp;
    if (imageArr[0].url) {
        let { data } = await axios.get(imageArr[0].url, { responseType: 'arraybuffer' });
        imageSharp = sharp(Buffer.from(data)).resize( options.dimension.width, options.dimension.height )
        delete data
    }
    let compositeArr = []
    for (let i = 1; i < imageArr.length; i++) {
        let nextSharp;
        if (imageArr[i].url) {
            let { data } = await axios.get(imageArr[i].url, { responseType: 'arraybuffer' });
            nextSharp = sharp(Buffer.from(data))
            delete data
        } else if (imageArr[i].buffer) {
            nextSharp = sharp(imageArr[i].buffer)
        }
        compositeArr.push({ input: await nextSharp.toBuffer() })
    }
    imageSharp.composite(compositeArr)
    if (options.outputType == 'buffer') return imageSharp.toBuffer()
    if (options.outputType == 'file' && options.outputFile) {
        await imageSharp.toFile(options.outputFile)
        return options.outputFile
    }
    return imageSharp
}