const Fs = require('fs');
const AWS = require('aws-sdk');
const CONFIG = require('../config');

AWS.config.update({
    accessKeyId: CONFIG.S3_ACCESS_KEY,
    secretAccessKey: CONFIG.S3_SECRET_KEY,

});

const s3 = new AWS.S3({
    params: { Bucket: CONFIG.S3_BUCKET_NAME, },
    region: CONFIG.S3_REGION,
})

module.exports.uploadToAwsS3 = async function (localPath, remotePath,options) {

    const buffer = Fs.readFileSync(localPath);

    try {

        var params = {
            Body: buffer,
            Bucket: CONFIG.S3_BUCKET_NAME,
            Key: remotePath,
        };
        s3.putObject(params, function (err, data) {
            if (err) {
                console.log(err);
            }
            // successful response
        });
        if (options && !options.preventUnlink) {
            try { Fs.unlinkSync(localPath) }
            catch (err) { console.log(err) }
        }

        return
    } catch (error) {
        console.log(error);
        return { status: httpStatus.NETWORK_ERROR, path: remotePath }
    }
}

module.exports.generatePreSignedGetUrl = async function (fileName) {
    return await new Promise((resolve, reject) => {
        s3.getSignedUrl('getObject', {
            Key: fileName,
        }, (err, url) => {
            resolve(url); // successful response
        });
    })
}